'Finalna verzija
'ne koristi AL1

$crystal = 16000000
$regfile = "m328pdef.dat"
'$regfile = "m168def.dat"
$hwstack = 48
$swstack = 32
$framesize = 48

Config Clockdiv = 1

Waitms 500

$include "DS3231$SE.sub"

Dim Hh As Byte , Mm As Byte , Ss As Byte
Dim Hh_tmp As Byte , Mm_tmp As Byte , Ss_old As Byte
Dim Set_indeks As Byte , Loop_counter As Byte
Dim Led_g As Word , Led_r As Word
Dim I As Byte , T_button As Byte

Col_1 Alias Portc.1
Col_2 Alias Portc.2
Col_3 Alias Portd.2
Col_4 Alias Portd.3
Col_5 Alias Portb.0
Col_6 Alias Portb.1
Col_7 Alias Portb.2
Col_8 Alias Portb.3
Row_1 Alias Portd.7
Row_2 Alias Portd.6
Row_3 Alias Portd.5
Row_4 Alias Portd.4

Row_1 = 1 : Config Row_1 = Output
Row_2 = 1 : Config Row_2 = Output
Row_3 = 1 : Config Row_3 = Output
Row_4 = 1 : Config Row_4 = Output

Col_1 = 0 : Config Col_1 = Output
Col_2 = 0 : Config Col_2 = Output
Col_3 = 0 : Config Col_3 = Output
Col_4 = 0 : Config Col_4 = Output
Col_5 = 0 : Config Col_5 = Output
Col_6 = 0 : Config Col_6 = Output
Col_7 = 0 : Config Col_7 = Output
Col_8 = 0 : Config Col_8 = Output

Set_button Alias Pinc.0
Portc.0 = 1 : Config Set_button = Input

Sqw Alias Pinc.3
Portc.3 = 1 : Config Sqw = Input

Config Sda = Portc.5
Config Scl = Portc.4
I2cinit
Waitms 10

Config Timer0 = Timer , Prescale = 64
On Timer0 Disp
Enable Timer0
Enable Interrupts

'Config Timer2 = Timer , Prescale = 1024 , Compare_a = Toggle , Clear_timer = 1
'Stop Timer2
'Compare2a = 200

Ds3231$write_control &B00000000

Led_g = 0
Led_r = 0
Hh = 0
Mm = 0
Set_indeks = 0
Loop_counter = 0

Do
  Debounce Set_button , 0 , Set_time , Sub
  If Set_indeks = 0 Then
    Waitms 20
    Gosub Read_hhmmss
    Gosub Disp_hh
    Gosub Disp_mm
    If Ss <> Ss_old Then
      Ss_old = Ss
      Led_r.7 = 1
      Loop_counter = 0
    End If
    If Loop_counter < 25 Then
      Incr Loop_counter
    Else
      Led_r.7 = 0
    End If
  End If
Loop

Set_time:
  T_button = 0
  While Set_button = 0
    Waitms 10
    Incr T_button
    If T_button > 100 Then Exit While
  Wend
  If T_button > 100 Then
    If Set_indeks = 0 Then
      Set_indeks = 1
      Gosub Blink_hh
      Led_r.7 = 1
    Elseif Set_indeks = 1 Then
      Set_indeks = 2
      Gosub Blink_mm
      Led_r.7 = 1
    Else
      Set_indeks = 0
      Ss = 0
      Gosub Write_hhmmss
      Gosub Blink_hhmm
      Led_r.7 = 0
    End If
  Else
    If Set_indeks = 1 Then
      Hh_tmp = Makedec(hh)
      Incr Hh_tmp
      If Hh_tmp > 23 Then Hh_tmp = 0
      Hh = Makebcd(hh_tmp)
      Gosub Disp_hh
    Elseif Set_indeks = 2 Then
      Mm_tmp = Makedec(mm)
      Incr Mm_tmp
      If Mm_tmp > 59 Then Mm_tmp = 0
      Mm = Makebcd(mm_tmp)
      Gosub Disp_mm
    End If
  End If
Return

Read_hhmmss:
  Ds3231$read
  Hh = Ds3231$hour
  Mm = Ds3231$min
  Ss = Ds3231$sec
Return

Write_hhmmss:
  Ds3231$hour = Hh
  Ds3231$min = Mm
  Ds3231$sec = Ss
  Ds3231$write_time
Return

Blink_hh:
  Hh_tmp = Hh
  Mm_tmp = Mm
  Mm = &H00
  Gosub Disp_mm
  Hh = &HFF
  For I = 1 To 10
    Gosub Disp_hh
    Waitms 100
    Hh = Not Hh
  Next
  Hh = Hh_tmp
  Gosub Disp_hh
  Mm = Mm_tmp
Return

Blink_mm:
  Hh_tmp = Hh
  Mm_tmp = Mm
  Hh = &H00
  Gosub Disp_hh
  Mm = &HFF
  For I = 1 To 10
    Gosub Disp_mm
    Waitms 100
    Mm = Not Mm
  Next
  Hh = Hh_tmp
  Mm = Mm_tmp
  Gosub Disp_mm
Return

Blink_hhmm:
  Hh_tmp = Hh
  Mm_tmp = Mm
  Hh = &HFF
  Mm = &HFF
  For I = 1 To 10
    Gosub Disp_hh
    Gosub Disp_mm
    Waitms 100
    Hh = Not Hh
    Mm = Not Mm
  Next
  Hh = Hh_tmp
  Mm = Mm_tmp
  Gosub Disp_hh
  Gosub Disp_mm
Return

Disp_hh:
'  Goto Disp_hh_r
'  Goto Disp_hh_g
  Goto Disp_hh_y
Return

Disp_mm:
'  Goto Disp_mm_r
'  Goto Disp_mm_g
  Goto Disp_mm_y
Return

Disp_hh_r:
  Led_g = Led_g And &B1111111110000001
Disp_hh_r1:
  Led_r.1 = Hh.4
  Led_r.2 = Hh.5
  Led_r.3 = Hh.0
  Led_r.4 = Hh.1
  Led_r.5 = Hh.2
  Led_r.6 = Hh.3
Return

Disp_mm_r:
  Led_g = Led_g And &B1000000011111111
Disp_mm_r1:
  Led_r.8 = Mm.4
  Led_r.9 = Mm.5
  Led_r.10 = Mm.6
  Led_r.11 = Mm.0
  Led_r.12 = Mm.1
  Led_r.13 = Mm.2
  Led_r.14 = Mm.3
Return

Disp_hh_g:
  Led_r = Led_r And &B1111111110000001
Disp_hh_g1:
  Led_g.1 = Hh.4
  Led_g.2 = Hh.5
  Led_g.3 = Hh.0
  Led_g.4 = Hh.1
  Led_g.5 = Hh.2
  Led_g.6 = Hh.3
Return

Disp_mm_g:
  Led_r = Led_r And &B1000000011111111
Disp_mm_g1:
  Led_g.8 = Mm.4
  Led_g.9 = Mm.5
  Led_g.10 = Mm.6
  Led_g.11 = Mm.0
  Led_g.12 = Mm.1
  Led_g.13 = Mm.2
  Led_g.14 = Mm.3
Return

Disp_hh_y:
  Gosub Disp_hh_r1
  Gosub Disp_hh_g1
Return

Disp_mm_y:
  Gosub Disp_mm_r1
  Gosub Disp_mm_g1
Return

Disp:
  If Row_1 = 0 Then
    Row_1 = 1
    Gosub Disp_row2
    Row_2 = 0
  Elseif Row_2 = 0 Then
    Row_2 = 1
    Gosub Disp_row3
    Row_3 = 0
  Elseif Row_3 = 0 Then
    Row_3 = 1
    Gosub Disp_row4
    Row_4 = 0
  Else
    Row_4 = 1
    Gosub Disp_row1
    Row_1 = 0
  End If
Return

Disp_row1:
  Col_1 = 0
  Col_2 = 0
  Col_3 = Led_g.6
  Col_4 = Led_r.6
  Col_5 = Led_g.7
  Col_6 = Led_r.7
  Col_7 = Led_g.14
  Col_8 = Led_r.14
Return

Disp_row2:
  Col_1 = 0
  Col_2 = 0
  Col_3 = Led_g.5
  Col_4 = Led_r.5
  Col_5 = Led_g.10
  Col_6 = Led_r.10
  Col_7 = Led_g.13
  Col_8 = Led_r.13
Return

Disp_row3:
  Col_1 = Led_g.2
  Col_2 = Led_r.2
  Col_3 = Led_g.4
  Col_4 = Led_r.4
  Col_5 = Led_g.9
  Col_6 = Led_r.9
  Col_7 = Led_g.12
  Col_8 = Led_r.12
Return

Disp_row4:
  Col_1 = Led_g.1
  Col_2 = Led_r.1
  Col_3 = Led_g.3
  Col_4 = Led_r.3
  Col_5 = Led_g.8
  Col_6 = Led_r.8
  Col_7 = Led_g.11
  Col_8 = Led_r.11
Return